%Graficas 2d y 3d
%
%
x=linspace(0,3,100)
plot(sin(x))
plot(x,sin(x))
plot(x,sin(x),"*")
plot(x,sin(x),"@")
plot(x,sin(x),"-@")
plot(x,sin(x),';funcion seno;')
plot(x,sin(x),"+4;funcion seno;")
% "_" une los datos mediante segmentos de lnea (opcin por defecto).
% '. ' asigna un punto a cada dato
% '@ ' asigna un + para cada dato
%'-@' une los puntos de cada dato con segmentos de lnea.
%'^ ' grfica estilo impulso (lnea que va desde cero hasta el punto)
%'n ' asigna un color a los datos, donde n es un dgito del 0 al 6 (¿ó 9?) que representa el color.
%'nm ' asigna un color n y un estilo de puntom
%";etiqueta;"
plot(x,sin(x),"4@")

%varios graficos juntos con sus distintas opciones
%
plot(x,[sin(x);cos(x)])
plot([x;2*x],sin(x))
plot (x,cos(x),x,sin(x))
plot (x, cos(x), ';cos(x);',x, sin(x), ';sin(x);')
plot (x, cos(x), ';cos(x);',sin(x), ';sin(x);') %observar el error
plot (x,';x;', cos(x), ';cos(x);', sin(x), ';sin(x);')%ojo, ver la agrupacion, funcion+opciones y ver abscisa
plot (x, cos(x), ';cos(x);',x, sin(x), ';sin(x);')
plot (x, cos(x),['@', ';cos(x);'],x, sin(x), ';sin(x);')
plot (x, cos(x),['@', ';cos(x);'],x, sin(x),['4',';sin(x);'])

%algunas formas raras
y=x+3;
plot([x,y],[sin(x),sin(3)+y-3])% funcion a trozos, ojo con lo que sigue, que hemos puesto ; en lugar de ,
plot([x;y],[sin(x);sin(3)+y-3])
plot(1,3,'*')
plot (x,sin(x), "*", "markersize", 6)
plot(x,sin(x),"3@")


hold on %o simplemente hold, mantiene la grfica y superpone las sucesivas
hold off
ishold %da el estado del hold 0  1


%pelicula de gráficas, añadimos comando sleep(tiempo) al for para que se detenga un poco entre cada iteración del for 

for k=1:10  plot(x,sin(k*x)); sleep(0.3) endfor


xlabel('etiqueta x') %no tienen que estar dentro del plot, sino después, o usando hold
ylabel('etiqueta y')
zlabel('etiqueta z')
title('titulo del grafico')


clearplot %limpia todo en la ventana grficas
clg %idem, compatible matlab



bar(rand(10))%diagrama de barras
bar(x,sin(x))  %ver comando colormap para cambiar colores...
barh(x,sin(x)) %diagrama de barras horizontal 



y=1:0.5:100;
semilogx(y,log(y)) %realiza la grfica utilizando una escala logartmica en el eje x
semilogy(y,exp(y)) %realiza la grfica utilizando una escala logartmica en el eje y.
loglog(y,y,'+') %utiliza una escala logartmica en ambos ejes.


t=linspace(0,2*pi,50);
r=linspace(0,1,50);
polar(t,r) %produce la gráfica de una curva en polares: t=angulo y r=radio

plotyy(x,sin(x),x,x.^2) % produce una gráfica con ejes y distintos para cada plot	

%y otras cosas

hist (randn (1, 1000), 25, "facecolor", "r", "edgecolor", "b"); %histogramas

stem (x, sin(2*x));%pinta como plot pero poniendo rallitas

%[r, t] = rose ([2*randn(1e5,1), pi + 2*randn(1e5,1)]); %bueno, para jugar, ver help
 %polar (r, t)

clf %borramos

%pasamos a 3d
%
%

x=linspace(-3,3,50);
y=x;
z=exp(-x.^2)'*exp(-y.^2)/(2*pi); %nótese que z es una matriz; 
%en este ejemplo la función se puede factorial, pero 
%como definir z si no es así, cambia la cosa sen(norma(x,y))/norma(x,y)…? ver mas abajo meshgrid


contour(x,y,z) %curvas nivel (10 por defecto)
contourf (x,y,z) %idem rellenas
contour3 (x, y, z) %las curvas de nivel, pero levantadas en 3d	
plot3 (x,y,z)
mesh (x,x,z)

x=linspace(-8,8,50);
[xx,yy] = meshgrid(x,x); %o simplemente meshgrid(x)
z=sqrt(xx.^2+yy.^2)+eps;
z=sin(z)./z;	%el famoso sombrero (ojo con el puntito antes de dividir ./!!!!)



contour(x,y,z,12)%12 es el número de curvas de nivel, si se pone un vector, serán los niveles de control a dibujar
plot3 (x,y,z)
mesh (x,x,z)
surf (x,x,z) %como mesh pero relleno
surfc (x,x,z) %idem incluyendo curvas de nivel
surfl (x,x,z) %idem incluyendo iluminación


%una curva compleja

x=0:0.02:2*pi;
plot3 (x,sin(x/2).*exp(20i*x) ) %cuando el segundo argumento es un vector de complejos


%curvas en general
x=0:0.2:10*pi;
r=linspace(0,1,length(x));
plot3 (r.*sin(x), r.*cos(x), x); %en realidad, tanto plot como plot3 pintan curvas en paramétricas




%varios graficos

subplot(2,3,1); %dos filas 3 columnas, posicion 1
surf (x,x,z); 
title('surf');
subplot(2,3,2); 
surfc (x,x,z); 
title('surfc');
subplot(2,3,3); 
plot3 (x,x,z); 
title('plot3'); 
subplot(2,2,3); %se pueden mezclar
mesh (x,x,z);
title('mesh');
subplot(2,2,4);
contour3 (x,x,z);
title('contour3');


%sobre el número de ventanas gráficas
%
% Para obtener diferentes grficas en distintas ventanas, podemos usar el comando figure() como sigue
%
figure (1)
plot(...)
%
figure (2)
plotyy (...)
%
etc
% de este modo, lo ejecutado tras un  figure(n) se dibujar en el terminal con el 
% nmero n asignado y no afectar al resto.
%




